PRO make_GFS_anal_dat2_pl

infl=GETENV('INFL')
print,'infl= ',infl
indir=GETENV('INDIR')
outdir=GETENV('OUTDIR')
yyyymmdd=GETENV('YYYYMMDD')

hr_str=strmid(infl,16,2)
year_str=strmid(yyyymmdd,0,4)
month_str=strmid(yyyymmdd,4,2)
day_str=strmid(yyyymmdd,6,2)
print,month_str,day_str,year_str,hr_str

;psfl='plot_bin'
;setplot='ps'
;set_plot,setplot
;xsize=10.
;ysize=8.
;device,/color,bits=8,/landscape,$
; filename=psfl+'.ps'
;device,/inch,xoff=4.25-ysize/2.,yoff=5.5+xsize/2.,$
; xsize=xsize,ysize=ysize

;set_plot,'x'
;device,decomposed=1,pseudo_color=8

nz=26L
nx=360L
ny=181L
nx=720L
ny=361L
data2d=fltarr(nx,ny)
lpnmc=fltarr(nz)
       lpnmc(0)=1000.
       lpnmc(1)=975.
       lpnmc(2)=950.
       lpnmc(3)=925.
       lpnmc(4)=900.
       lpnmc(5)=850.
       lpnmc(6)=800.
       lpnmc(7)=750.
       lpnmc(8)=700.
       lpnmc(9)=650.
       lpnmc(10)=600.
       lpnmc(11)=550.
       lpnmc(12)=500.
       lpnmc(13)=450.
       lpnmc(14)=400.
       lpnmc(15)=350.
       lpnmc(16)=300.
       lpnmc(17)=250.
       lpnmc(18)=200.
       lpnmc(19)=150.
       lpnmc(20)=100.
       lpnmc(21)=70.
       lpnmc(22)=50.
       lpnmc(23)=30.
       lpnmc(24)=20.
       lpnmc(25)=10.
alon=.5*findgen(nx)
alat=-90.+.5*findgen(ny)
close,1
openr,1,indir+infl,/f77_unformatted
readu,1,data2d
;print,'ubl',max(data2d),min(data2d)
ubl=data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,'vbl',max(data2d),min(data2d)
vbl=data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,'qbl',max(data2d),min(data2d)
qbl=data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,'land',max(data2d),min(data2d)
land=data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,'mslp',max(data2d),min(data2d)
mslp=data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,'zsfc',max(data2d),min(data2d)
zsfc=data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,'tsfc',max(data2d),min(data2d)
tsfc=data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
psfc=data2d
dataold=data2d
;readu,1,data2d
;index=where(data2d ne dataold)
;if index(0) eq -1 then readu,1,data2d
;print,'apcp',max(data2d),min(data2d)
;apcp=data2d
;dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,'zpbl',max(data2d),min(data2d)
zpbl=data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
print,'clw',max(data2d),min(data2d)
clw=data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
ptrp=data2d
apcp=0.*ptrp


for k=0L,nz-1L do begin
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,k,'u',max(data2d),min(data2d)
if k eq 0L then u3d=data2d
if k gt 0L then boost_array,u3d,data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,k,'v',max(data2d),min(data2d)
if k eq 0L then v3d=data2d
if k gt 0L then boost_array,v3d,data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,k,'t',max(data2d),min(data2d)
if k eq 0L then t3d=data2d
if k gt 0L then boost_array,t3d,data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,k,'z',max(data2d),min(data2d)
if k eq 0L then z3d=data2d
if k gt 0L then boost_array,z3d,data2d
endfor
for k=0L,nz-6L do begin
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,k,'q',max(data2d),min(data2d)
if k eq 0L then q3d=data2d
if k gt 0L then boost_array,q3d,data2d
dataold=data2d
readu,1,data2d
index=where(data2d ne dataold)
if index(0) eq -1 then readu,1,data2d
;print,k,'w',max(data2d),min(data2d)
if k eq 0L then w3d=data2d
if k gt 0L then boost_array,w3d,data2d
endfor
;
; add zero water vapor and vertical velocity above 100mb
;
data2d=0.*data2d
boost_array,q3d,data2d
boost_array,q3d,data2d
boost_array,q3d,data2d
boost_array,q3d,data2d
boost_array,q3d,data2d
data2d=0.*data2d
boost_array,w3d,data2d
boost_array,w3d,data2d
boost_array,w3d,data2d
boost_array,w3d,data2d
boost_array,w3d,data2d


;change to 'eta_12Z_**' where **=forecast hour
;change month,day,year,hour to forecast valid time
openw,10,outdir+'gfs_'+month_str+'_'+day_str+'_'+year_str+'_'+hr_str+'Z.dat',/f77
print,'outfl=','gfs_'+month_str+'_'+day_str+'_'+year_str+'_'+hr_str+'Z.dat'
;change hour,day,month,year->long
;
; swap latitudes so data goes sp->np
;
alat=reverse(alat)
for i=0,nx-1 do begin
mslp(i,*)=reverse(reform(mslp(i,*),ny))
zsfc(i,*)=reverse(reform(zsfc(i,*),ny))
psfc(i,*)=reverse(reform(psfc(i,*),ny))
apcp(i,*)=reverse(reform(apcp(i,*),ny))
ubl(i,*)=reverse(reform(ubl(i,*),ny))
vbl(i,*)=reverse(reform(vbl(i,*),ny))
qbl(i,*)=reverse(reform(qbl(i,*),ny))
land(i,*)=reverse(reform(land(i,*),ny))
zpbl(i,*)=reverse(reform(zpbl(i,*),ny))
clw(i,*)=reverse(reform(clw(i,*),ny))
ptrp(i,*)=reverse(reform(ptrp(i,*),ny))

for l=0,nz-1 do begin
u3d(i,*,l)=reverse(reform(u3d(i,*,l),ny))
v3d(i,*,l)=reverse(reform(v3d(i,*,l),ny))
w3d(i,*,l)=reverse(reform(w3d(i,*,l),ny))
t3d(i,*,l)=reverse(reform(t3d(i,*,l),ny))
q3d(i,*,l)=reverse(reform(q3d(i,*,l),ny))
z3d(i,*,l)=reverse(reform(z3d(i,*,l),ny))
endfor
endfor
;
; swap levels so data goes from top to bottom
;
lpnmc=reverse(lpnmc)
for i=0,nx-1 do begin
for j=0,ny-1 do begin
u3d(i,j,*)=reverse(reform(u3d(i,j,*),nz))
v3d(i,j,*)=reverse(reform(v3d(i,j,*),nz))
w3d(i,j,*)=reverse(reform(w3d(i,j,*),nz))
t3d(i,j,*)=reverse(reform(t3d(i,j,*),nz))
q3d(i,j,*)=reverse(reform(q3d(i,j,*),nz))
z3d(i,j,*)=reverse(reform(z3d(i,j,*),nz))
endfor
endfor
print,'hr_str',hr_str
print,'day_str',day_str
print,'month_str',month_str
print,'year_str',year_str
writeu,10,long(hr_str),long(day_str),long(month_str),long(year_str)
writeu,10,nx,ny,nz
writeu,10,alon,alat,lpnmc
writeu,10,u3d,v3d,w3d,t3d,q3d,z3d
writeu,10,apcp,zsfc,psfc
writeu,10,ubl,vbl,qbl,land,zpbl,clw,ptrp
close,10
;
; open input file for binary to netcdf fortran code
;
ffil='GFS_datfiles.fil'
openw,10,ffil
nfiles=1
printf,10,nfiles
printf,10,'"gfs_'+month_str+'_'+day_str+'_'+year_str+'_'+hr_str+'Z."'
close,10
; MAIN program
spawn,'/home/bpierce/Arvani/Pre_process_GFS/GFS_press_v3.x'


end
